Bug 1113946 - Parallel depmod failure with dkms autoinstall
Summary: Parallel depmod failure with dkms autoinstall
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: dkms
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Simone Caronni
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-06-27 10:14 UTC by Julien Floret
Modified: 2014-09-02 06:43 UTC (History)
7 users (show)

Fixed In Version: dkms-2.2.0.3-25.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-07-26 16:00:24 UTC


Attachments (Terms of Use)
0001-Prevent-parallel-depmod-failure-with-autoinstall.patch (977 bytes, patch)
2014-06-27 10:14 UTC, Julien Floret
no flags Details | Diff

Description Julien Floret 2014-06-27 10:14:10 UTC
Created attachment 912746 [details]
0001-Prevent-parallel-depmod-failure-with-autoinstall.patch

Description of problem:

dkms autoinstall installs DKMS modules in parallel and potentially executes
several depmod instances in parallel.

The resulting race condition causes depmod to fail and dkms install as well.

This is critical, because it leaves a few DKMS modules in built state after
a kernel upgrade and makes it unusable in a production environment.

Attached a simple patch that fixes the problem by running modules installation
sequentially.

Version-Release number of selected component (if applicable):

dkms-2.2.0.3-21.el7.noarch

How reproducible:

Very frequent when installing several DKMS modules.

Steps to Reproduce:

1.

$ dkms add -m module1 -v version1
$ dkms add -m module2 -v version2

2.

# dkms autoinstall

Actual results:

depmod...
depmod...(bad exit status: 1)
Error! Problems with depmod detected.  Automatically uninstalling this module.
DKMS: Install Failed (depmod problems).  Module rolled back to built state.

$ dkms status
module1, version1, 3.14.4-200.fc20.x86_64, x86_64: installed
module2, version2, 3.14.4-200.fc20.x86_64, x86_64: built

Expected results:

$ dkms status
module1, version1, 3.14.4-200.fc20.x86_64, x86_64: installed
module2, version2, 3.14.4-200.fc20.x86_64, x86_64: installed

Comment 1 Simone Caronni 2014-06-27 15:54:03 UTC
Thanks for the patch, applied:

http://pkgs.fedoraproject.org/cgit/dkms.git/commit/?id=13538559728e0a1cc78d5f1d882731948316808f

Comment 2 Simone Caronni 2014-07-23 15:30:05 UTC
I will submit an update along with #1109601; sorry for the delay.

Comment 3 Fedora Update System 2014-07-23 16:47:36 UTC
dkms-2.2.0.3-25.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/dkms-2.2.0.3-25.el6

Comment 4 Fedora Update System 2014-07-23 16:48:01 UTC
dkms-2.2.0.3-25.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/dkms-2.2.0.3-25.el5

Comment 5 Fedora Update System 2014-07-23 16:48:34 UTC
dkms-2.2.0.3-25.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/dkms-2.2.0.3-25.fc20

Comment 6 Fedora Update System 2014-07-23 17:03:15 UTC
dkms-2.2.0.3-25.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/dkms-2.2.0.3-25.fc19

Comment 7 Fedora Update System 2014-07-23 22:41:05 UTC
Package dkms-2.2.0.3-25.el6:
* should fix your issue,
* was pushed to the Fedora EPEL 6 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing dkms-2.2.0.3-25.el6'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2014-2008/dkms-2.2.0.3-25.el6
then log in and leave karma (feedback).

Comment 8 Fedora Update System 2014-07-23 22:41:09 UTC
Package dkms-2.2.0.3-25.el5:
* should fix your issue,
* was pushed to the Fedora EPEL 5 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing dkms-2.2.0.3-25.el5'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2014-2010/dkms-2.2.0.3-25.el5
then log in and leave karma (feedback).

Comment 9 Fedora Update System 2014-07-26 16:00:24 UTC
dkms-2.2.0.3-25.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2014-09-02 03:53:53 UTC
dkms-2.2.0.3-25.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2014-09-02 03:56:10 UTC
dkms-2.2.0.3-25.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2014-09-02 06:43:01 UTC
dkms-2.2.0.3-25.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.